image: alpine:latest

variables:
  MAVEN_OPTS: "-Dhttps.protocols=TLSv1.2 -Dmaven.repo.local=.m2/repository -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=WARN -Dorg.slf4j.simpleLogger.showDateTime=true -Djava.awt.headless=true"
  MAVEN_CLI_OPTS: "--batch-mode --errors --fail-at-end --show-version -DinstallAtEnd=true -DdeployAtEnd=true"

stages:
  - build
  - test

build:
  stage: build
  image: maven:3-jdk-11
  script:
    - 'mvn $MAVEN_OPTS $MAVEN_CLI_OPTS -DskipTests=true package'
  only:
    - branches
  artifacts:
    paths:
      - target/*.jar

test:
  stage: test
  image: maven:3-jdk-11
  script:
    - 'mvn $MAVEN_OPTS $MAVEN_CLI_OPTS verify'
    - echo $(awk -F, "{ instructions += \$4 + \$5; covered += \$5 } END { print \"Total:\", 100*covered/instructions\"%\" }" ./target/site/jacoco/jacoco.csv)
  only:
    - branches
  except:
    variables:
      - $TEST_DISABLED

code_quality:
  stage: test
  image: docker:stable
  variables:
    DOCKER_DRIVER: overlay2
  allow_failure: true
  services:
    - docker:stable-dind
  script:
    - setup_docker
    - code_quality
  artifacts:
    paths: [gl-code-quality-report.json]
  only:
    - branches
  except:
    variables:
      - $CODE_QUALITY_DISABLED

sast:
  stage: test
  image: docker:stable
  variables:
    DOCKER_DRIVER: overlay2
  allow_failure: true
  services:
    - docker:stable-dind
  script:
    - setup_docker
    - sast
  artifacts:
    paths: [gl-sast-report.json]
  only:
    - branches
  except:
    variables:
      - $SAST_DISABLED

dependency_scanning:
  stage: test
  image: docker:stable
  variables:
    DOCKER_DRIVER: overlay2
  allow_failure: true
  services:
    - docker:stable-dind
  script:
    - setup_docker
    - dependency_scanning
  artifacts:
    paths: [gl-dependency-scanning-report.json]
  only:
    - branches
  except:
    variables:
      - $DEPENDENCY_SCANNING_DISABLED
